import { BootstrapConstructor } from "./bootstrap-constructor";
export declare class DisposableSingletonContainer {
    private readonly singletonContainer;
    private readonly disposeSequenceMap;
    private disposeSequence;
    readonly bootstrap: BootstrapConstructor;
    constructor(singletonContainer?: Map<string, unknown>, disposeSequenceMap?: Map<number, Set<string>>, disposeSequence?: number, bootstrap?: BootstrapConstructor);
    createInstance<InstanceType>(name: string, typeConstructor: new (...constructorArguments: any[]) => InstanceType, constructorArguments?: any[], disposeSequence?: number): InstanceType;
    createInstanceWithoutConstructor<InstanceType>(name: string, typeConstructor: (...constructorArguments: any[]) => Promise<InstanceType>, constructorArguments?: any[], disposeSequence?: number): Promise<InstanceType>;
    disposeInstance(name: string): Promise<void>;
    disposeAll(): Promise<void>;
}
